/* soutezici c. 30 */

#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

#define OFFSET 30
#define SIZE 40

int pole[10][10];
int n; /* rozmer */
int xcur,ycur; /* pozice kurzoru */
int natahu = 0;
int body[2];
int zbyva;  /* pocet neuzavrenych ctvercu */

const int colors[2] = {10, 11};

void drawcur(int mode);
void add(void);
void drawpozice(int p);
void printbody(void);
int jedokonceno(int xcur,int ycur);
void konec(void);
void topten(int);

int main(void)
{
   int i,c;

   /* request auto detection */
   int gdriver = DETECT, gmode, errorcode;
   clrscr();
   while (1) {
     printf("Zadej velikost hraciho pole (1-10): ");
     scanf("%d",&n);
     if (n>0 && n<11) break;
     printf("Velikost hraciho pole musi byt v intervalu 1 az 10.\n");
   }
   zbyva = n*n;
   /* initialize graphics mode */
   initgraph(&gdriver, &gmode, "");

   /* read result of initialization */
   errorcode = graphresult();

   if (errorcode != grOk)  /* an error occurred */
   {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:");
      getch();
      exit(1);             /* return with error code */
   }
   asm {
    mov ax,1;
    int 0x33;
   }

   setcolor(9);
   for(i = 0; i <= n; i++) {
     line(SIZE*i+OFFSET,OFFSET,SIZE*i+OFFSET,SIZE*n+OFFSET);
     line(OFFSET,SIZE*i+OFFSET,SIZE*n+OFFSET,SIZE*i+OFFSET);
   }
   xcur = 0;
   ycur = 0;
   drawcur(1);
   printbody();
   while (1) {
/*     gotoxy(1,1);  DEBUG
     printf("%d ",pole[xcur][ycur]); */

     c = getch();
     switch (c) {

       case 'q':
       case 'Q': goto quit;
       case 13 : drawcur(2);
		 add();
		 printbody();
		 if (zbyva == 0) {
		   konec();
		   return 0;
		 }
		 drawcur(1);
		 break;
       case 0: c=getch(); switch (c) {
       case 80: drawcur(2);
		ycur++;
		if (ycur == n) ycur--;
		drawcur(1);
		break;
	 case 72:
		drawcur(2);
		ycur--;
		if (ycur == -1) ycur++;
		drawcur(1);
		break;
       case 75: drawcur(2);
		xcur--;
		if (xcur == -1) xcur++;
		drawcur(1);
		break;
       case 77: drawcur(2);
		xcur++;
		if (xcur == n) xcur--;
		drawcur(1);
		break;
       } break;
     }


   }
   /* clean up */
   quit:
   closegraph();
   return 0;
}

void drawcur(int mode) {

  if (mode == 2) {
     if (pole[xcur][ycur] > 14) {
       setfillstyle(1,colors[pole[xcur][ycur]-20]);
     } else setfillstyle(1,0);
     setcolor(0);
     bar(OFFSET+xcur*SIZE+3,OFFSET+ycur*SIZE+3,OFFSET+(xcur+1)*SIZE-3,OFFSET+(ycur+1)*SIZE-3);
  }
  else {
    setfillstyle(1,colors[natahu]);
    setcolor(0);
    fillellipse(OFFSET+SIZE/2+SIZE*xcur,OFFSET+SIZE/2+SIZE*ycur,10,10);
  }
}

void add(void) {
  int c,zmena = 1;
  int pozice;
  if (pole[xcur][ycur] > 14) return; /* plno */
  if (!(pole[xcur][ycur] & 1)) pozice = 1; else
    if (!(pole[xcur][ycur] & 2)) pozice = 2; else
	  if (!(pole[xcur][ycur] & 4)) pozice = 4; else pozice = 8;
  drawpozice(pozice);
  while (1) {
    c = getch();
    if (c==27) { drawpozice(-pozice); return; }
    if (c==13) {
       drawpozice(pozice*10);
       pole[xcur][ycur] |= pozice;
       switch (pozice) {
	 case 1: if (ycur != 0) pole[xcur][ycur-1] |= 4;  zmena *= jedokonceno(xcur,ycur-1); break;
	 case 2: if (xcur != n-1) pole[xcur+1][ycur] |= 8; zmena *= jedokonceno(xcur+1,ycur); break;
	 case 4: if (ycur != n-1) pole[xcur][ycur+1] |= 1; zmena *= jedokonceno(xcur,ycur+1);break;
	 case 8: if (xcur != 0) pole[xcur-1][ycur] |= 2; zmena *= jedokonceno(xcur-1,ycur);break;
       }
       zmena *= jedokonceno(xcur,ycur);
       if (zmena) natahu ^= 1;  /* zmena hrace */
       return;
    }
    if (c==0) c = getch();
    drawpozice(-pozice);
    switch (c) {
      case 72 : if (!(pole[xcur][ycur] & 1)) pozice = 1; break;
      case 77 : if (!(pole[xcur][ycur] & 2)) pozice = 2; break;
      case 80 : if (!(pole[xcur][ycur] & 4)) pozice = 4; break;
      case 75 : if (!(pole[xcur][ycur] & 8)) pozice = 8; break;
    }
    drawpozice(pozice);
  }
}

void drawpozice(int p) {
  int x=OFFSET + SIZE*xcur;
  int y=OFFSET + SIZE*ycur;
  if (p>0) setcolor(12); else { setcolor(0); p *= -1;}
  if (p>9) { setcolor(14); p = p/10; }
  switch (p) {
    case 1 : line(x+1,y-1,x+SIZE-1,y-1);
	     line(x+1,y+1,x+SIZE-1,y+1); break;
    case 8 : line(x-1,y+1,x-1,y+SIZE-1);
	     line(x+1,y+1,x+1,y+SIZE-1); break;
    case 4 : line(x+1,y+SIZE-1,x+SIZE-1,y+SIZE-1);
	     line(x+1,y+SIZE+1,x+SIZE-1,y+SIZE+1); break;
    case 2 : line(x+1+SIZE,y+1,x+1+SIZE,y+SIZE-1);
	     line(x-1+SIZE,y+1,x-1+SIZE,y+SIZE-1); break;
  }
}

void printbody(void) {
  gotoxy(58,5);
  printf("Na tahu je hrac: %d",natahu+1);
  gotoxy(58,7);
  printf("Body:");
  gotoxy(58,8);
  printf("Hrac 1: %d",body[0]);
  gotoxy(58,9);
  printf("Hrac 2: %d",body[1]);
}

int jedokonceno(int xcur,int ycur) {
   if (pole[xcur][ycur] == 15) {
	body[natahu]++;
	setfillstyle(1,colors[natahu]);
	bar(OFFSET+xcur*SIZE+3,OFFSET+ycur*SIZE+3,OFFSET+(xcur+1)*SIZE-3,OFFSET+(ycur+1)*SIZE-3);
	pole[xcur][ycur] = 20 + natahu;
	zbyva --;
	return 0;
   } else return 1;
}

void konec(void) {
  int win = body[0] > body[1] ? 0 : 1;
  gotoxy(20,23);
  printf("Zvitezil hrac %d s %d body.",win+1,body[win]);
  topten(body[win]);
}

void topten(int bodyhrace) {
  FILE *f;
  struct {
    char *str;
    int n;
    int b;
  } top[10];
  int i=0,j,k,c;
  char *str;

  f = fopen("sirky.top","a");
  fclose(f);

  f = fopen("sirky.top","rb");
  while (i < 11) {
    j = 0;
    c = getc(f);
    if (c == EOF) break;
    top[i].str[j] = c;
    while ((c = getc(f))!=0) top[i].str[j] = c;
    top[i].n = getc(f);
    top[i].b = getc(f);
    i++;
  }
  fclose(f);

  i--;
  if (i < 10 || top[i-1].b < bodyhrace) {
    gotoxy(20,24);
    printf("Dosahl jsi Top 10 score, zadej svoje jmeno: ");
    scanf("%s",str);
    f = fopen("sirky.top","wb");
    j = 0;
    while(j < i && bodyhrace <= top[j].b) {
      k = 0;
      while (top[j].str[k] != 0) putc(top[j].str[k++],f);
      putc(0,f);
      putc(top[j].n,f);
      putc(top[j].b,f);
      j++;
    }
    k = 0;
    while (str[k] != 0) putc(str[k++],f);
    putc(0,f);
    putc(n,f);
    putc(bodyhrace,f);
    while(j < 9 && j < i) {
      k = 0;
      while (top[j].str[k] != 0) putc(top[j].str[k++],f);
      putc(0,f);
      putc(top[j].n,f);
      putc(top[j].b,f);
      j++;
    }
    fclose(f);
  } else getch();

  closegraph();
  printf("\n\n\n     TOP 10 SCORE\n");
  printf("   -----------------------------------------------\n");
  printf("         Jmeno              Rozmer       Body\n");
  printf("   -----------------------------------------------\n");
  f = fopen("sirky.top","rb");
  i = 1;
  while (1) {
    c = getc(f);
    if (c == EOF) break;
    printf("      %d.  ",i);
    printf("%c",c);
    while ((c = getc(f)) != 0) printf("%c",c);
      c = getc(f);
      gotoxy(30,i+7);
      printf("   %2d",c);
      c = getc(f);
      i++;
      printf("   %3d\n",c);
  }
  fclose(f);
  getch();
}